/*
	create the BApplication just to get at the location of
	the executable we're running.
	
	[990117 jono] created
*/

// const char* 
status_t get_parent_path_of_entry_ref(const entry_ref & ref, char* dst)
	{
		BEntry bentry;
		{
			status_t status = bentry.SetTo(&ref, false);
			if (status != B_OK)
				return status;
		}
			
		BPath bpath;
		{
			status_t status = bpath.SetTo(&bentry);
			if (status != B_OK)
				return status;
		}
		
		BPath bpath_parent;
		{			
			// status_t status = bpath.GetParent(&bpath);
				// allowed; see BeBook/BPath
			
			status_t status = bpath.GetParent(&bpath_parent);
			if (status != B_OK)
				return status;
		}
		
		const char* tmp = bpath_parent.Path();		// this name is gone
		strcpy(dst, tmp);
		
		// ATTN: <bpath> is destroyed -> tmp is invalid.
		
		return B_OK;
	}


status_t 
do_get_path_dir_executable(char* dst)
	{
		const char *app_signature 
			= "application/x-vnd.Be-'get_path_dir_executable'";
			// hm...what if someone else uses this function!?!?
			
		BApplication the_app(app_signature);
		
		app_info the_app_info;
		{
			status_t status = 
				the_app.GetAppInfo(&the_app_info);
			if (status != B_OK)
				return status;
		}
		
		entry_ref ref_executable = the_app_info.ref;
			// file:///boot/beos/documentation/Be Book/The Storage Kit/misc.html#entry_ref
		
		return get_parent_path_of_entry_ref(ref_executable, dst);
		
		/*	
			// never mind this! [990118 03:22]
			
			const char* name_executable = (const char*)ref_executable.name;
				// this is just the name of the executable, not the path!
			
			const char* path_executable
			strcpy(buf_path_dir_executable, path_executable);
			
			if (modify_path_to_path_dir(buf_path_dir_executable))
			{
				path_executable = buf_path_dir_executable;
			}
		*/	
	}

extern "C" 
const char* ret_path_dir_executable()
	// get the path to the directory where the executable sits.
	// note that we are returning as <const char*>
	// a return of zero indicates failure of some sort
	{
		static char buf_path_dir_executable[B_PATH_NAME_LENGTH] = "";
		static char* path_dir_executable = 0;
		
		if (!path_dir_executable)
		{
			do_get_path_dir_executable(buf_path_dir_executable);
			path_dir_executable = buf_path_dir_executable;
		}
		
		// printf("-- get_path_dir_executable()\n");
		// printf("--   -> '%s'\n", path_dir_executable);
		
		if (path_dir_executable)
		{
			return path_dir_executable;
		}
		else
		{
			// return "/";				// the root directory.
			
			return 0;
		}
	}
	
char* wr_ztstr(char* dst, const char* src)
	{
		char* p_dst = dst;
		const char* p_src = src;
		while (p_src[0])
		{
			p_dst[0] = p_src[0];
			p_src++;
			p_dst++;
		}
		return p_dst;
	}
	
extern "C"
char* 
wr_path_dir_executable(char* dst)
	{
		if (const char* path_exe = ret_path_dir_executable())
		{
			return wr_ztstr(dst, path_exe);
		}
		else
		{
			return 0;		// failure
		}
	}

// EOF