#ifndef mjono
#else
	#include <dlfcn.h>
#endif

#include "mlvalues.h"
#include "fail.h"

/* Ken Larsen (kla@it.dtu.dk) 1998-01-08 */

value dynlib_dlopen(value libname, value flagval) /* ML */
{
	#ifndef mjono
		
		// [990914] jono
		// I don't know how to implement this in BeOS!
		
		failwith("dynlib_dlopen not supported");
		return Val_unit;
		
	#else
		
		  void *handle;
		  int mlflags = Long_val(flagval);
		  int cflags;
		  if (1 & mlflags) 
		    cflags = RTLD_NOW;
		  else
		    cflags = RTLD_LAZY;
		#ifndef __osf__     
		  if (2 & mlflags)
		    cflags += RTLD_GLOBAL;
		#endif 
		
		  handle = dlopen (String_val(libname), cflags);
		  if (!handle) {
		    failwith(dlerror());
		  }
		
		  /* Since handle is a void pointer, we can just cast it to value */
		  return (value) handle;
		  
	#endif
}

value dynlib_dlclose(value handle) /* ML */
{
	#ifndef mjono
		
		// [990914] jono
		// I don't know how to implement this in BeOS!
		
		failwith("dynlib_dlopen not supported");
		return Val_unit;
		
	#else
	
	  dlclose((void *) handle);
	  return Val_unit;
	 
	 #endif
}

value dynlib_dlsym(value handle, value sym) /* ML */
{
	#ifndef mjono
		
		// [990914] jono
		// I don't know how to implement this in BeOS!
		
		failwith("dynlib_dlopen not supported");
		return Val_unit;
		
	#else
	  void *symhdl;
	
	  symhdl = dlsym((void *) handle, String_val(sym));
	  {   
	    const char *error = dlerror();
	    if (error != NULL)  
	      failwith(error);
	  }
	  return (value) symhdl;
	#endif
}

value dynlib_var(value symhdl) /* ML */
{
  return *((value *) symhdl);
}

value dynlib_app1(value cfun, value arg)  /* ML */
{
  /* Due to the heavy typecasting, I had to declare a temp variable in
     order to get it right.  
  */
  value (*cp)(value) = (value (*)(value)) cfun;

  return (*cp)(arg);
}

value dynlib_app2(value cfun, value arg1, value arg2)  /* ML */
{
  /* again a typecast value */
  value (*cp)(value,value) = (value (*)(value,value)) cfun;

  return (*cp)(arg1,arg2);
}

value dynlib_app3(value cfun, value arg1, value arg2, value arg3)  /* ML */
{
  /* again a typecast value */
  value (*cp)(value,value,value) = (value (*)(value,value,value)) cfun;

  return (*cp)(arg1,arg2,arg3);
}

value dynlib_app4(value cfun, value arg1, value arg2, value arg3, value arg4)  /* ML */
{
  /* again a typecast value */
  value (*cp)(value,value,value,value) = 
    (value (*)(value,value,value,value)) cfun;

  return (*cp)(arg1,arg2,arg3,arg4);
}

value dynlib_app5(value args, int argc)  /* ML */
{
  value cfun = Field(args, 0);
  value arg1 = Field(args, 1);
  value arg2 = Field(args, 2);
  value arg3 = Field(args, 3);
  value arg4 = Field(args, 4);
  value arg5 = Field(args, 5);
  
  /* again a typecast value */
  value (*cp)(value,value,value,value,value) = 
    (value (*)(value,value,value,value,value)) cfun;

  return (*cp)(arg1,arg2,arg3,arg4,arg5);
}
